import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { Thickness } from "igniteui-angular-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-angular-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { MarkerCollisionMode } from "./MarkerCollisionMode";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected ct(): SeriesView;
    o8(): void;
    q7(a: SeriesView): void;
    y7: ScatterBaseView;
    protected get_fx(): boolean;
    ai(): Axis[];
    ku(a: any, b: string): any;
    mi(a: string): string;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected b3(): SeriesHitTestMode;
    wz(a: Point): Rect;
    gx(a: Point, b: boolean): boolean;
    constructor();
    y6: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    aa3: string;
    get zr(): IFastItemColumn$1<number>;
    set zr(a: IFastItemColumn$1<number>);
    private zp;
    abb: string;
    get zs(): IFastItemColumn$1<number>;
    set zs(a: IFastItemColumn$1<number>);
    private zq;
    aan: string;
    aap: string;
    protected gc(): boolean;
    protected z6(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private abi;
    private abj;
    aaz: string;
    aa7: string;
    aa1: string;
    aa9: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acs(): Brush;
    set acs(a: Brush);
    static readonly ab3: DependencyProperty;
    trendLineThickness: number;
    acu: PenLineCap;
    act: DoubleCollection;
    trendLinePeriod: number;
    y3: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    aak: number;
    aaj: number;
    zi: ScatterItemSearchMode;
    aai: number;
    qh(): void;
    y8: ScatterErrorBarSettings;
    protected rg(a: any, b: string, c: any, d: any): void;
    protected z3(): boolean;
    protected z2(): boolean;
    zx(a: any): boolean;
    zw(a: any): boolean;
    private ab1;
    private acv;
    private acw;
    private abd;
    protected z1(a: string, b: FastItemsSourceEventAction): boolean;
    protected ph(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    abs(a: ScatterFrame): void;
    abt(a: ScatterFrame, b: Clipper): void;
    ay(a: Axis): AxisRange;
    kr(a: Point): any;
    private zf;
    get zg(): ScatterItemSearchMode;
    set zg(a: ScatterItemSearchMode);
    protected zh(): ScatterItemSearchMode;
    j7(a: Point): number;
    it(a: Point): number;
    protected aae(a: Point): number;
    private yw;
    private yx;
    protected aad(a: Point): number;
    private abg;
    protected get_z0(): boolean;
    protected get z0(): boolean;
    private aah;
    protected aag(a: Point): number;
    protected aac(a: Point): number;
    protected aaf(a: Point): number;
    wm(a: Point, b: boolean, c: boolean): Point;
    ge(a: any): boolean;
    protected sy(a: Rect, b: Rect): void;
    protected sz(a: Rect, b: Rect): void;
    zc: ScatterFrame;
    ze: ScatterFrame;
    za: ScatterFrame;
    zb(): ScatterFrame;
    abe(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    abp(a: ScatterFrame, b: ScatterBaseView): void;
    pb(a: boolean, b: SeriesView): void;
    zz: boolean;
    zy: boolean;
    protected zv: boolean;
    protected zu: boolean;
    protected get_ff(): boolean;
    private zn;
    private zo;
    protected zl(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zm(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    w5(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected zk(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected z5(): boolean;
    protected z4(): boolean;
    ab0(a: ScatterFrame, b: ScatterBaseView): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    qa(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    abh(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: MarkerCollisionMode, e: IFastItemColumn$1<number>): void;
    yz(a: number, b: number): any[];
    protected y0(a: number, b: number): any[];
    protected zj: ScatterSeriesRenderManager;
    abf(a: ScatterBaseView, b: ScatterFrame): void;
    protected abl(a: number, b: number, c: boolean): void;
    protected abk(a: number, b: number, c: boolean): void;
    protected abv(a: AssigningScatterStyleEventArgs): void;
    protected abu(a: AssigningScatterMarkerStyleEventArgs): void;
    abn(a: ScatterFrame, b: ScatterBaseView): void;
    abq(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    abo(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    abm(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    abr(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    abx(a: ScatterFrame, b: ScatterBaseView): void;
    private aby;
    private abz;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    rz(a: boolean): void;
    protected sp(): void;
    zd: ScatterFrame;
    r0(a: Rect, b: RenderSurface): void;
    r1(): void;
    private y9;
    rx(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abw(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yy(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    z7(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected p5(a: any): void;
    i0(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private zt;
    private z8;
    private z9;
    aaa: number;
    aab: number;
    private ab2;
    jb(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wq(a: number[]): Point;
    wp(a: ValueLayerValueMode): Point;
    bd(): ITrendLineManager;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    dd: MarkerManagerBase;
    protected db: Point[];
    protected de: ScatterBase;
    protected dj: List$1<number>;
    constructor(a: ScatterBase);
    private dv;
    private dw;
    df: ScatterTrendLineManager;
    a4(): void;
    private du;
    dx(a: Marker): Size;
    protected dc(): MarkerManagerBase;
    protected ds(a: IDictionary$2<any, OwnedPoint>): void;
    di(): List$1<Marker>;
    da(): Point[];
    protected c9(): Point[];
    protected dh(): List$1<number>;
    dk(): void;
    dq(a: PathGeometry): void;
    dl(): void;
    dr(a: PathGeometry): void;
    dt(): void;
    dg: HashPool$2<any, Marker>;
    cw(a: (arg1: Marker) => void): void;
    dn(a: (arg1: Marker) => void): void;
    dp(): void;
    protected bi(a: RenderingContext, b: boolean): void;
    dm(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
